/**
 * Created with
 * @author: 林子/junhui.zhang@htwins.com.cn
 * @data: 17-9-25
 * @time: 下午1:27
 * @file: 获取浏览器版本信息
 */

angular.module('htwins.ui.service.browser', [])
  .service('htBrowser', [function () {

    /**
     * 获取当前系统
     * @return {*}
     */
    this.getOS = function () {
      if (navigator.platform.indexOf("Win") != -1) return "Windows";
      if (navigator.platform.indexOf("Mac") != -1) return "Mac";
      if (navigator.platform.indexOf("Linux") != -1) return "Linux";
      if (navigator.userAgent.indexOf("iPhone") != -1) return "iPhone/iPod";
    };

    /**
     * 获取浏览器版本
     * @return {*}
     */
    this.getBrowser = function () {
      var rMsie = /(msie\s|trident\/7)([\w\.]+)/;
      var rTrident = /(trident)\/([\w.]+)/;
      var rFirefox = /(firefox)\/([\w.]+)/;
      var rOpera = /(opera).+version\/([\w.]+)/;
      var rNewOpera = /(opr)\/(.+)/;
      var rChrome = /(chrome)\/([\w.]+)/;
      var rSafari = /version\/([\w.]+).*(safari)/;
      var ua = navigator.userAgent.toLowerCase();
      var matchBS, matchBS2;
      matchBS = rMsie.exec(ua);
      if (matchBS != null) {
        matchBS2 = rTrident.exec(ua);
        if (matchBS2 != null) {
          switch (matchBS2[2]) {
            case "4.0":
              return {browser: "IE", version: "8"};
              break;
            case "5.0":
              return {browser: "IE", version: "9"};
              break;
            case "6.0":
              return {browser: "IE", version: "10"};
              break;
            case "7.0":
              return {browser: "IE", version: "11"};
              break;
            default:
              return {browser: "IE", version: "Undefined"};
          }
        } else {
          return {browser: "IE", version: matchBS[2] || "0"};
        }
      }
      matchBS = rFirefox.exec(ua);
      if ((matchBS != null) && (!(window.attachEvent)) && (!(window.chrome)) && (!(window.opera))) {
        return {browser: matchBS[1] || "", version: matchBS[2] || "0"};
      }
      matchBS = rOpera.exec(ua);
      if ((matchBS != null) && (!(window.attachEvent))) {
        return {browser: matchBS[1] || "", version: matchBS[2] || "0"};
      }
      matchBS = rChrome.exec(ua);
      if ((matchBS != null) && (!!(window.chrome)) && (!(window.attachEvent))) {
        matchBS2 = rNewOpera.exec(ua);
        if (matchBS2 == null) {
          return {browser: matchBS[1] || "", version: matchBS[2] || "0"};
        } else {
          return {browser: "Opera", version: matchBS2[2] || "0"};
        }
      }
      matchBS = rSafari.exec(ua);
      if ((matchBS != null) && (!(window.attachEvent)) && (!(window.chrome)) && (!(window.opera))) {
        return {browser: matchBS[2] || "", version: matchBS[1] || "0"};
      }
    };

    //初始化操作
    this.init = {
      browser: this.getBrowser().browser || "An Unknown Browser",
      version: this.getBrowser().version || "An Unknown Version",
      OS: this.getOS() || "An Unknown OS"
    };
    
  }]);
