/**
 * Created with
 * @author: 林子/junhui.zhang@htwins.com.cn
 * @data: 17-8-30
 * @time: 上午10:33
 * @file:
 */
angular.module('htwins.ui.service.class', [])
  .service('htClass', [function () {
    //解决ie8不支持问题
    if (!document.getElementsByClassName) {
      document.getElementsByClassName = function (className, element) {
        var children = (element || document).getElementsByTagName('*');
        var elements = new Array();
        for (var i = 0; i < children.length; i++) {
          var child = children[i];
          var classNames = child.className.split(' ');
          for (var j = 0; j < classNames.length; j++) {
            if (classNames[j] == className) {
              elements.push(child);
              break;
            }
          }
        }
        return elements;
      };
    }

    return {
      /**
       * 判断样式是否存在
       * @param obj 要修改的dom树
       * @param cls 样式名字
       * @return {Array|{index: number, input: string}}
       */
      hasClass: function (obj, cls) {
        return obj.className.match(new RegExp('(\\s|^)' + cls + '(\\s|$)'));
      },

      /**
       * 为指定的dom元素添加样式
       * @param obj 要修改的dom树
       * @param cls 样式名字
       */
      addClass: function (obj, cls) {
        if (!this.hasClass(obj, cls)) obj.className += " " + cls;
      },

      /**
       * 删除指定dom元素的样式
       * @param obj 要修改的dom树
       * @param cls 样式名字
       */
      removeClass: function (obj, cls) {
        if (this.hasClass(obj, cls)) {
          var reg = new RegExp('(\\s|^)' + cls + '(\\s|$)');
          obj.className = obj.className.replace(reg, ' ');
        }
      },

      /**
       * 如果存在(不存在)，就删除(添加)一个样式
       * @param obj 要修改的dom树
       * @param cls 样式名字
       */
      toggleClass: function (obj, cls) {
        if (this.hasClass(obj, cls)) {
          this.removeClass(obj, cls);
        } else {
          this.addClass(obj, cls);
        }
      },

      /**
       * 解决ie8不支持getElementsByClassName
       * @param className 样式名字
       * @param element dom树
       * @return {Array}
       */
      getElementsByClassName: function (className, element) {
        var children = (element || document).getElementsByTagName('*');
        var elements = new Array();
        for (var i = 0; i < children.length; i++) {
          var child = children[i];
          var classNames = child.className.split(' ');
          for (var j = 0; j < classNames.length; j++) {
            if (classNames[j] == className) {
              elements.push(child);
              break;
            }
          }
        }
        return elements;
      },
      
    }
  }]);
